<?php
/**
 * @name		Menu Manager CK
 * @package		com_menumanagerck
 * @copyright	Copyright (C) 2014. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */

defined('_JEXEC') or die;
jimport('joomla.application.component.modellist');
require_once (JPATH_ROOT.'/administrator/components/com_menumanagerck/models/custom.php');
require_once (JPATH_ADMINISTRATOR.'/components/com_hikashop/helpers/helper.php');

class MenumanagerckModelCustomhikashopcategory extends MenumanagerckModelCustom
{
	protected $context = 'com_menumanagerck.customhikashopcategory';

	public $pagination;

	public function __construct($config = array())
	{
		parent::__construct($config);
	}

	public function showSearchBar()
	{
		return true;
	}

	public function getCustomColumn()
	{
		return Array('title' => null, 'tag' => null, 'sort' => null);
	}
	
	public function getOrderingColumn()
	{
		return Array('title' => JText::_('JGRID_HEADING_ORDERING'), 'tag' => 'category_ordering', 'sort' => 'a.category_ordering');
	}

	public function getCustomFilters()
	{
		$app = JFactory::getApplication();
		$customfilters = '';

		// filter for parent category
		$class = hikashop_get('class.category');
		$categories_select = $class->getList('product', 0, false);
		$customfilters = '<select name="filter_id" class="input-medium" onchange="this.form.submit()">'
			. '<option value="0">- ' . JText::_('JCATEGORY') . ' -</option>'
			. JHtml::_('select.options', $categories_select, 'category_id', 'category_name', $this->state->get('filter_id'))
		. '</select>';

		return $customfilters;
	}
	
	public function getItems()
	{
		$categories = $this->listing();

		return $categories;
	}
	
	public function getObjectAssociation() {
		$names = new stdClass();
		$names->title = 'category_name';
		$names->level = 'category_depth';
		$names->language = 'language';
		$names->id = 'category_id';

		return $names;
	}

	/**
	 * Method to get model state variables
	 *
	 * @param   string  $property  Optional parameter name
	 * @param   mixed   $default   Optional default value
	 *
	 * @return  object  The property where specified, the state object where omitted
	 *
	 * @since   12.2
	 */
	public function getState($property = null, $default = null)
	{
		$this->populateState();

		return $property === null ? $this->state : $this->state->get($property, $default);
	}
	
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @param   string  $ordering   An optional ordering field.
	 * @param   string  $direction  An optional direction (asc|desc).
	 *
	 * @return  void
	 *
	 * @since   1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication();

		$search = $this->getUserStateFromRequest($this->context . '.search', 'filter_search');
		$this->setState('filter.search', $search);
		$this->setState('filter_id', $this->getUserStateFromRequest($this->context . '.filter_id', 'filter_id', 0));
		$this->setState('list.limit', $this->getUserStateFromRequest($this->context.'.limit', 'limit', $app->getCfg('list_limit'), 'int' ));
		// List state information.
		$filter_order = $app->getUserStateFromRequest($this->context.'.filter_order', 'filter_order', "a.category_ordering", 'cmd');
		$filter_order_Dir = $app->getUserStateFromRequest($this->context.'.filter_order_Dir', 'filter_order_Dir', "asc", 'cmd');
		parent::populateState($filter_order, $filter_order_Dir);
	}
	
	/**
	 * Method to get a store id based on model configuration state.
	 *
	 * This is necessary because the model is used by the component and
	 * different modules that might need different sets of data or different
	 * ordering requirements.
	 *
	 * @param   string  $id  A prefix for the store id.
	 *
	 * @return  string  A store id.
	 *
	 * @since   1.6
	 */
	protected function getStoreId($id = '')
	{
		// Compile the store id.
		$id .= ':' . $this->getState('filter.search');
		$id .= ':' . $this->getState('filter.extension');
		$id .= ':' . $this->getState('filter.published');
		$id .= ':' . $this->getState('filter.language');

		return parent::getStoreId($id);
	}
	
	/**
	 * Method to get a JPagination object for the data set.
	 *
	 * @return  JPagination  A JPagination object for the data set.
	 *
	 * @since   12.2
	 */
	public function getPagination()
	{
		return $this->pagination;
	}
	
	private function listing(){
		$app = JFactory::getApplication();
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $this->context.".filter_order", 'filter_order',	'a.category_ordering','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $this->context.".filter_order_Dir", 'filter_order_Dir',	'asc',	'word' );
		if(JRequest::getVar('search')!=$app->getUserState($this->context.".search")){
			$app->setUserState( $this->context.'.limitstart',0);
			$pageInfo->limit->start = 0;
		}else{
			$pageInfo->limit->start = $app->getUserStateFromRequest( $this->context.'.limitstart', 'limitstart', 0, 'int' );
		}
		$pageInfo->search = $app->getUserStateFromRequest( $this->context.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower( $pageInfo->search );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $this->context.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );

		$pageInfo->selectedType = $app->getUserStateFromRequest( $this->context.".filter_type",'filter_type',0,'int');
		$pageInfo->filter->filter_id = $app->getUserStateFromRequest( $this->context.".filter_id",'filter_id',0,'string');

		$database = JFactory::getDBO();

		$order = '';
		if(!empty($pageInfo->filter->order->value)){
			$order = ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$config =& hikashop_config();
		// $this->assignRef('config',$config);
		// $category_image = $config->get('category_image',1);

		$class = hikashop_get('class.category');
		// $type='';
		$categories = false;
		$category_id = $pageInfo->filter->filter_id;
		if(is_numeric($pageInfo->filter->filter_id)){
			$cat=$class->get($pageInfo->filter->filter_id);
			// if(@$cat->category_type!='root'){
				// $type = @$cat->category_type;
			// }
		}else{
			// $type = $pageInfo->filter->filter_id;
			$class->getMainElement($category_id);
		}
		
		if($pageInfo->selectedType){
			$childs = $class->getChilds((int)$category_id,true,array(),'',0,0);
			$cat_ids = array();
			foreach($childs as $child){
				$cat_ids[$child->category_id]=$child->category_id;
			}
		}else{
			$cat_ids = array((int)$category_id);
		}
		$parent_cat_ids = array();
		if(!empty($cat_ids)){
			$parents = $class->getParents($cat_ids,true,array(),'',0,0);
			if(!empty($parents)){
				foreach($parents as $parent){
					$parent_cat_ids[]=$parent->category_id;
				}
			}
		}
		$categories=array('originals'=>$cat_ids,'parents'=>$parent_cat_ids);
		$searchMap = array('a.category_name','a.category_description','a.category_id');
		$fieldsClass = hikashop_get('class.field');
		$fields = $fieldsClass->getData('backend_listing','category',false,$categories);
		// $this->assignRef('fields',$fields);
		// $this->assignRef('fieldsClass',$fieldsClass);
		foreach($fields as $field){
			$searchMap[]='a.'.$field->field_namekey;
		}
		$filters = array();
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.hikashop_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchMap)." LIKE $searchVal";
		}
		// if($type=='tax'||$type=='status'){
			// $category_image = false;
		// }
		// $this->assignRef('type',$type);
		// $rows = $class->loadAllWithTrans('product',false,$filters,$order,$pageInfo->limit->start,$pageInfo->limit->value,false);
		$rows = $class->loadAllWithTrans($pageInfo->filter->filter_id,true, $filters, $order, $pageInfo->limit->start,$pageInfo->limit->value,false);

		if(!empty($pageInfo->search)){
			$rows = hikashop_search($pageInfo->search,$rows,'category_id');
		}
		$database->setQuery('SELECT COUNT(*)'.$class->query);
		$pageInfo->elements = new stdClass();
		$pageInfo->elements->total = $database->loadResult();
		$pageInfo->elements->page = count($rows);
		
		jimport('joomla.html.pagination');
		$limit = $app->getUserStateFromRequest($this->context.'.limit', 'limit', $app->getCfg('list_limit'), 'int' );
        $limitstart = $app->getUserStateFromRequest($this->context.'.limitstart', 'limitstart', 0, 'int' );
        $this->pagination = new JPagination($pageInfo->elements->total, $limitstart, $limit);

		return $rows;
	}
}
